;
;	HighRes & Blank & Lowres(Color)Test, End with ESC
;	V1.0 2024 TB
;

ACIA_S 		= $F000
ACIA_D 		= $F001
VIDEO_RAM	= $D000
KEYB 		= $FD00
RESET		= $FF00
mode		= $FC		; Temp Display mode register


START_ADR = $0350 

	.ORG	START_ADR
	
	
	

	LDY	#0
	sty	mode
	jsr	SET
	JSR	CLS


LMAIN:
	jsr	SNUM		; Set 0..255 to screen (4x) test pattern
	JSR	KEYB		; wait for input

	lda	#$35
	sta	mode
	jsr	SET		; Char RAM 4th 1k

	lda	#$D6
	jsr	CLSA		; clear 1k segment of hires ram with yellow on blue

	lda	#$01		; Set Char RAM display Mode
	sta	mode
	jsr	SET
	
L1:	JSR	KEYB		; wait for input
	cmp	#27
	beq	ESC

	lda	mode
	eor	#$80		; Toggle BLANK
	sta	mode
	jsr	SET
	JSR	KEYB		; wait for input 
	cmp	#27
	beq	ESC
	
	lda	mode
	eor	#$80		; Toggle BLANK
	sta	mode
	jsr	SET
	JSR	KEYB		; wait for input
	cmp	#27
	beq	ESC

	lda	mode
	eor	#$40		; Togge Mono/Color mode
	sta	mode
	jsr	SET
	
	jmp	L1
	
ESC:	lda	#$00
	sta	mode
	jsr	SET		; Char RAM 4th 1k
	jmp	RESET


; ******************************************************************************

SNUM:
	ldy	#$00			; Set 32x32 Screen with 0,1,2,..

LSN:	tya
	sta	VIDEO_RAM,y
	sta	VIDEO_RAM+$100,y
	sta	VIDEO_RAM+$200,y
	sta	VIDEO_RAM+$300,y
	iny
	bne	LSN

	rts


; ******************************************************************************
		
CLS:
	lda	#$20
CLSA:	ldy	#$00			; Clear 32x32 Screen with $20

LCLS:
	sta	VIDEO_RAM,y
	sta	VIDEO_RAM+$100,y
	sta	VIDEO_RAM+$200,y
	sta	VIDEO_RAM+$300,y
	iny
	bne	LCLS
	rts

;
	
; ******************************************************************************
SET:	
	lda $D000
	sta $D000
        lda $D3FF
        sta $D3FF
	lda mode
        sta $D3FF
	lda $D000
	sta $D000        
        rts
        

