;
;	Increment two Character RAM effecting 4 characters on the screen (with same character number)
;	V1.0 2024 TB
;

ACIA_S 		= $F000
ACIA_D 		= $F001
VIDEO_RAM	= $D000
KEYB 		= $FD00
mode		= $FC


START_ADR = $1000		; 

	.ORG	START_ADR


	LDY	#0
	sty	mode
	jsr	SET
	JSR	CLS


LMAIN:
	jsr	SNUM		; Set 128..255 to screen (8x) for having 2 times characters within one char RAM segement
	JSR	KEYB		; wait for input

	lda	#$35
	sta	mode
	jsr	SET		; Char RAM 4th 1k

	lda	#0
	jsr	CLSA		; clear 1k segment of hires ram

	lda	#$01
	sta	mode
	jsr	SET
	
	JSR	KEYB		; wait for input

L1:	jsr	TEST6
	ldy	#0
L2:	dey
	bne	L2	
	jmp	L1



; ********************* T6 increment singel byte in space caharczer ***********************

TEST6:
	ldy	mode
	lda	#$35
	sta	mode
	jsr	SET		; Char RAM 3rd 1k
	sty	mode
	
	inc	$D144
	inc	$D1C4

	jmp	SET		; Back to last mode
	
; ******************************************************************************

SNUM:
	ldy	#$FF			; Set 32x32 Screen with 0,1,2,..

LSN:	tya
	sta	VIDEO_RAM,y
	sta	VIDEO_RAM+$100,y
	sta	VIDEO_RAM+$200,y
	sta	VIDEO_RAM+$300,y
	dey
	bmi	LSN
	
	ldx	#$FF
	
LSN2:	txa
	sta	VIDEO_RAM,y
	sta	VIDEO_RAM+$100,y
	sta	VIDEO_RAM+$200,y
	sta	VIDEO_RAM+$300,y
	dex
	dey
	bpl	LSN2	
	
	
	rts


; ******************************************************************************
		
CLS:
	lda	#$20
CLSA:	ldy	#$00			; Clear 32x32 Screen with $20

LCLS:
	sta	VIDEO_RAM,y
	sta	VIDEO_RAM+$100,y
	sta	VIDEO_RAM+$200,y
	sta	VIDEO_RAM+$300,y
	iny
	bne	LCLS
	rts



; ******************************************************************************
SET:	
	lda $D000
	sta $D000
        lda $D3FF
        sta $D3FF
	lda mode
        sta $D3FF
	lda $D000
	sta $D000        
        rts
        
;