;
;	Full Charset replacement Test
;	V1.0 2024 TB
;


VIDEO_RAM	= $D000
mode		= $FC
font		= $FD
RESET		= $FF00

START_ADR = $0350		; 

	.ORG	START_ADR

	lda	#$01		; Set main display mode
	sta	mode
	jsr	SET

	ldx	#$00
	lda	#<IBM
	sta	font

L0:	lda	#>IBM
	sta	font+1
	jsr	CPSEG		; Transfer 1k(x) of IBM charset to character RAM
	inc	font+1
	inx
	jsr	CPSEG
	inx
	cpx	#$08
	bcc	L0

	jmp	RESET



; ******************************************************************************
SET:	lda $D000
        sta $D000
        lda $D3FF
        sta $D3FF
        lda mode
        sta $D3FF
        rts


; ******************************************************************************

CPSEG:	ldy	mode		; Copy 1k from font address to character RAM segment x (0..7)
	txa
	and	#$07
	asl
	asl
	ora	#$21
	sta	mode
	jsr	SET
	sty	mode

	lda	font+1
	ldy	#$0
CP2:	pha
	lda	(font),y
	sta	VIDEO_RAM,y
	inc	font+1
	lda	(font),y
	sta	VIDEO_RAM+$100,y
	inc	font+1
	lda	(font),y
	sta	VIDEO_RAM+$200,y
	inc	font+1
	lda	(font),y
	sta	VIDEO_RAM+$300,y
	pla
	sta	font+1
	iny
	bne	CP2
	jmp	SET



IBM:
	.DB $00, $00, $00, $00, $00, $00, $00, $00, $7E, $81, $A5, $81
	.DB $BD, $99, $81, $7E, $7E, $FF, $DB, $FF, $C3, $E7, $FF, $7E
	.DB $36, $7F, $7F, $7F, $3E, $1C, $08, $00, $08, $1C, $3E, $7F
	.DB $3E, $1C, $08, $00, $1C, $3E, $1C, $7F, $7F, $6B, $08, $1C
	.DB $08, $08, $1C, $3E, $7F, $3E, $08, $1C, $00, $00, $18, $3C
	.DB $3C, $18, $00, $00, $FF, $FF, $E7, $C3, $C3, $E7, $FF, $FF
	.DB $00, $3C, $66, $42, $42, $66, $3C, $00, $FF, $C3, $99, $BD
	.DB $BD, $99, $C3, $FF, $F0, $E0, $F0, $BE, $33, $33, $33, $1E
	.DB $3C, $66, $66, $66, $3C, $18, $7E, $18, $FC, $CC, $FC, $0C
	.DB $0C, $0E, $0F, $07, $FE, $C6, $FE, $C6, $C6, $E6, $67, $03
	.DB $18, $DB, $3C, $E7, $E7, $3C, $DB, $18, $01, $07, $1F, $7F
	.DB $1F, $07, $01, $00, $40, $70, $7C, $7F, $7C, $70, $40, $00
	.DB $18, $3C, $7E, $18, $18, $7E, $3C, $18, $66, $66, $66, $66
	.DB $66, $00, $66, $00, $FE, $DB, $DB, $DE, $D8, $D8, $D8, $00
	.DB $7C, $C6, $1C, $36, $36, $1C, $33, $1E, $00, $00, $00, $00
	.DB $7E, $7E, $7E, $00, $18, $3C, $7E, $18, $7E, $3C, $18, $FF
	.DB $18, $3C, $7E, $18, $18, $18, $18, $00, $18, $18, $18, $18
	.DB $7E, $3C, $18, $00, $00, $18, $30, $7F, $30, $18, $00, $00
	.DB $00, $0C, $06, $7F, $06, $0C, $00, $00, $00, $00, $03, $03
	.DB $03, $7F, $00, $00, $00, $24, $66, $FF, $66, $24, $00, $00
	.DB $00, $18, $3C, $7E, $FF, $FF, $00, $00, $00, $FF, $FF, $7E
	.DB $3C, $18, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
	.DB $0C, $1E, $1E, $0C, $0C, $00, $0C, $00, $36, $36, $36, $00
	.DB $00, $00, $00, $00, $36, $36, $7F, $36, $7F, $36, $36, $00
	.DB $0C, $3E, $03, $1E, $30, $1F, $0C, $00, $00, $63, $33, $18
	.DB $0C, $66, $63, $00, $1C, $36, $1C, $6E, $3B, $33, $6E, $00
	.DB $06, $06, $03, $00, $00, $00, $00, $00, $18, $0C, $06, $06
	.DB $06, $0C, $18, $00, $06, $0C, $18, $18, $18, $0C, $06, $00
	.DB $00, $66, $3C, $FF, $3C, $66, $00, $00, $00, $0C, $0C, $3F
	.DB $0C, $0C, $00, $00, $00, $00, $00, $00, $00, $0C, $0C, $06
	.DB $00, $00, $00, $3F, $00, $00, $00, $00, $00, $00, $00, $00
	.DB $00, $0C, $0C, $00, $60, $30, $18, $0C, $06, $03, $01, $00
	.DB $3E, $63, $73, $7B, $6F, $67, $3E, $00, $0C, $0E, $0C, $0C
	.DB $0C, $0C, $3F, $00, $1E, $33, $30, $1C, $06, $33, $3F, $00
	.DB $1E, $33, $30, $1C, $30, $33, $1E, $00, $38, $3C, $36, $33
	.DB $7F, $30, $78, $00, $3F, $03, $1F, $30, $30, $33, $1E, $00
	.DB $1C, $06, $03, $1F, $33, $33, $1E, $00, $3F, $33, $30, $18
	.DB $0C, $0C, $0C, $00, $1E, $33, $33, $1E, $33, $33, $1E, $00
	.DB $1E, $33, $33, $3E, $30, $18, $0E, $00, $00, $0C, $0C, $00
	.DB $00, $0C, $0C, $00, $00, $0C, $0C, $00, $00, $0C, $0C, $06
	.DB $18, $0C, $06, $03, $06, $0C, $18, $00, $00, $00, $3F, $00
	.DB $00, $3F, $00, $00, $06, $0C, $18, $30, $18, $0C, $06, $00
	.DB $1E, $33, $30, $18, $0C, $00, $0C, $00, $3E, $63, $7B, $7B
	.DB $7B, $03, $1E, $00, $0C, $1E, $33, $33, $3F, $33, $33, $00
	.DB $3F, $66, $66, $3E, $66, $66, $3F, $00, $3C, $66, $03, $03
	.DB $03, $66, $3C, $00, $1F, $36, $66, $66, $66, $36, $1F, $00
	.DB $7F, $46, $16, $1E, $16, $46, $7F, $00, $7F, $46, $16, $1E
	.DB $16, $06, $0F, $00, $3C, $66, $03, $03, $73, $66, $7C, $00
	.DB $33, $33, $33, $3F, $33, $33, $33, $00, $1E, $0C, $0C, $0C
	.DB $0C, $0C, $1E, $00, $78, $30, $30, $30, $33, $33, $1E, $00
	.DB $67, $66, $36, $1E, $36, $66, $67, $00, $0F, $06, $06, $06
	.DB $46, $66, $7F, $00, $63, $77, $7F, $7F, $6B, $63, $63, $00
	.DB $63, $67, $6F, $7B, $73, $63, $63, $00, $1C, $36, $63, $63
	.DB $63, $36, $1C, $00, $3F, $66, $66, $3E, $06, $06, $0F, $00
	.DB $1E, $33, $33, $33, $3B, $1E, $38, $00, $3F, $66, $66, $3E
	.DB $36, $66, $67, $00, $1E, $33, $06, $0C, $18, $33, $1E, $00
	.DB $3F, $2D, $0C, $0C, $0C, $0C, $1E, $00, $33, $33, $33, $33
	.DB $33, $33, $3F, $00, $33, $33, $33, $33, $33, $1E, $0C, $00
	.DB $63, $63, $63, $6B, $7F, $77, $63, $00, $63, $63, $36, $1C
	.DB $1C, $36, $63, $00, $33, $33, $33, $1E, $0C, $0C, $1E, $00
	.DB $7F, $63, $31, $18, $4C, $66, $7F, $00, $1E, $06, $06, $06
	.DB $06, $06, $1E, $00, $03, $06, $0C, $18, $30, $60, $40, $00
	.DB $1E, $18, $18, $18, $18, $18, $1E, $00, $08, $1C, $36, $63
	.DB $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $FF
	.DB $0C, $0C, $18, $00, $00, $00, $00, $00, $00, $00, $1E, $30
	.DB $3E, $33, $6E, $00, $07, $06, $06, $3E, $66, $66, $3B, $00
	.DB $00, $00, $1E, $33, $03, $33, $1E, $00, $38, $30, $30, $3E
	.DB $33, $33, $6E, $00, $00, $00, $1E, $33, $3F, $03, $1E, $00
	.DB $1C, $36, $06, $0F, $06, $06, $0F, $00, $00, $00, $6E, $33
	.DB $33, $3E, $30, $1F, $07, $06, $36, $6E, $66, $66, $67, $00
	.DB $0C, $00, $0E, $0C, $0C, $0C, $1E, $00, $30, $00, $30, $30
	.DB $30, $33, $33, $1E, $07, $06, $66, $36, $1E, $36, $67, $00
	.DB $0E, $0C, $0C, $0C, $0C, $0C, $1E, $00, $00, $00, $33, $7F
	.DB $7F, $6B, $63, $00, $00, $00, $1F, $33, $33, $33, $33, $00
	.DB $00, $00, $1E, $33, $33, $33, $1E, $00, $00, $00, $3B, $66
	.DB $66, $3E, $06, $0F, $00, $00, $6E, $33, $33, $3E, $30, $78
	.DB $00, $00, $3B, $6E, $66, $06, $0F, $00, $00, $00, $3E, $03
	.DB $1E, $30, $1F, $00, $08, $0C, $3E, $0C, $0C, $2C, $18, $00
	.DB $00, $00, $33, $33, $33, $33, $6E, $00, $00, $00, $33, $33
	.DB $33, $1E, $0C, $00, $00, $00, $63, $6B, $7F, $7F, $36, $00
	.DB $00, $00, $63, $36, $1C, $36, $63, $00, $00, $00, $33, $33
	.DB $33, $3E, $30, $1F, $00, $00, $3F, $19, $0C, $26, $3F, $00
	.DB $38, $0C, $0C, $07, $0C, $0C, $38, $00, $18, $18, $18, $00
	.DB $18, $18, $18, $00, $07, $0C, $0C, $38, $0C, $0C, $07, $00
	.DB $6E, $3B, $00, $00, $00, $00, $00, $00, $00, $08, $1C, $36
	.DB $63, $63, $7F, $00, $1E, $33, $03, $33, $1E, $18, $30, $1E
	.DB $00, $33, $00, $33, $33, $33, $7E, $00, $38, $00, $1E, $33
	.DB $3F, $03, $1E, $00, $7E, $C3, $3C, $60, $7C, $66, $FC, $00
	.DB $33, $00, $1E, $30, $3E, $33, $7E, $00, $07, $00, $1E, $30
	.DB $3E, $33, $7E, $00, $0C, $0C, $1E, $30, $3E, $33, $7E, $00
	.DB $00, $00, $1E, $03, $03, $1E, $30, $1C, $7E, $C3, $3C, $66
	.DB $7E, $06, $3C, $00, $33, $00, $1E, $33, $3F, $03, $1E, $00
	.DB $07, $00, $1E, $33, $3F, $03, $1E, $00, $33, $00, $0E, $0C
	.DB $0C, $0C, $1E, $00, $3E, $63, $1C, $18, $18, $18, $3C, $00
	.DB $07, $00, $0E, $0C, $0C, $0C, $1E, $00, $63, $1C, $36, $63
	.DB $7F, $63, $63, $00, $0C, $0C, $00, $1E, $33, $3F, $33, $00
	.DB $38, $00, $3F, $06, $1E, $06, $3F, $00, $00, $00, $FE, $30
	.DB $FE, $33, $FE, $00, $7C, $36, $33, $7F, $33, $33, $73, $00
	.DB $1E, $33, $00, $1E, $33, $33, $1E, $00, $00, $33, $00, $1E
	.DB $33, $33, $1E, $00, $00, $07, $00, $1E, $33, $33, $1E, $00
	.DB $1E, $33, $00, $33, $33, $33, $7E, $00, $00, $07, $00, $33
	.DB $33, $33, $7E, $00, $00, $33, $00, $33, $33, $3E, $30, $1F
	.DB $C3, $18, $3C, $66, $66, $3C, $18, $00, $33, $00, $33, $33
	.DB $33, $33, $1E, $00, $18, $18, $7E, $03, $03, $7E, $18, $18
	.DB $1C, $36, $26, $0F, $06, $67, $3F, $00, $33, $33, $1E, $3F
	.DB $0C, $3F, $0C, $0C, $1F, $33, $33, $5F, $63, $F3, $63, $E3
	.DB $70, $D8, $18, $3C, $18, $18, $1B, $0E, $38, $00, $1E, $30
	.DB $3E, $33, $7E, $00, $1C, $00, $0E, $0C, $0C, $0C, $1E, $00
	.DB $00, $38, $00, $1E, $33, $33, $1E, $00, $00, $38, $00, $33
	.DB $33, $33, $7E, $00, $00, $1F, $00, $1F, $33, $33, $33, $00
	.DB $3F, $00, $33, $37, $3F, $3B, $33, $00, $3C, $36, $36, $7C
	.DB $00, $7E, $00, $00, $1C, $36, $36, $1C, $00, $3E, $00, $00
	.DB $0C, $00, $0C, $06, $03, $33, $1E, $00, $00, $00, $00, $3F
	.DB $03, $03, $00, $00, $00, $00, $00, $3F, $30, $30, $00, $00
	.DB $C3, $63, $33, $7B, $CC, $66, $33, $F0, $C3, $63, $33, $DB
	.DB $EC, $F6, $F3, $C0, $18, $18, $00, $18, $18, $18, $18, $00
	.DB $00, $CC, $66, $33, $66, $CC, $00, $00, $00, $33, $66, $CC
	.DB $66, $33, $00, $00, $44, $11, $44, $11, $44, $11, $44, $11
	.DB $AA, $55, $AA, $55, $AA, $55, $AA, $55, $DB, $EE, $DB, $77
	.DB $DB, $EE, $DB, $77, $18, $18, $18, $18, $18, $18, $18, $18
	.DB $18, $18, $18, $18, $1F, $18, $18, $18, $18, $18, $1F, $18
	.DB $1F, $18, $18, $18, $6C, $6C, $6C, $6C, $6F, $6C, $6C, $6C
	.DB $00, $00, $00, $00, $7F, $6C, $6C, $6C, $00, $00, $1F, $18
	.DB $1F, $18, $18, $18, $6C, $6C, $6F, $60, $6F, $6C, $6C, $6C
	.DB $6C, $6C, $6C, $6C, $6C, $6C, $6C, $6C, $00, $00, $7F, $60
	.DB $6F, $6C, $6C, $6C, $6C, $6C, $6F, $60, $7F, $00, $00, $00
	.DB $6C, $6C, $6C, $6C, $7F, $00, $00, $00, $18, $18, $1F, $18
	.DB $1F, $00, $00, $00, $00, $00, $00, $00, $1F, $18, $18, $18
	.DB $18, $18, $18, $18, $F8, $00, $00, $00, $18, $18, $18, $18
	.DB $FF, $00, $00, $00, $00, $00, $00, $00, $FF, $18, $18, $18
	.DB $18, $18, $18, $18, $F8, $18, $18, $18, $00, $00, $00, $00
	.DB $FF, $00, $00, $00, $18, $18, $18, $18, $FF, $18, $18, $18
	.DB $18, $18, $F8, $18, $F8, $18, $18, $18, $6C, $6C, $6C, $6C
	.DB $EC, $6C, $6C, $6C, $6C, $6C, $EC, $0C, $FC, $00, $00, $00
	.DB $00, $00, $FC, $0C, $EC, $6C, $6C, $6C, $6C, $6C, $EF, $00
	.DB $FF, $00, $00, $00, $00, $00, $FF, $00, $EF, $6C, $6C, $6C
	.DB $6C, $6C, $EC, $0C, $EC, $6C, $6C, $6C, $00, $00, $FF, $00
	.DB $FF, $00, $00, $00, $6C, $6C, $EF, $00, $EF, $6C, $6C, $6C
	.DB $18, $18, $FF, $00, $FF, $00, $00, $00, $6C, $6C, $6C, $6C
	.DB $FF, $00, $00, $00, $00, $00, $FF, $00, $FF, $18, $18, $18
	.DB $00, $00, $00, $00, $FF, $6C, $6C, $6C, $6C, $6C, $6C, $6C
	.DB $FC, $00, $00, $00, $18, $18, $F8, $18, $F8, $00, $00, $00
	.DB $00, $00, $F8, $18, $F8, $18, $18, $18, $00, $00, $00, $00
	.DB $FC, $6C, $6C, $6C, $6C, $6C, $6C, $6C, $FF, $6C, $6C, $6C
	.DB $18, $18, $FF, $18, $FF, $18, $18, $18, $18, $18, $18, $18
	.DB $1F, $00, $00, $00, $00, $00, $00, $00, $F8, $18, $18, $18
	.DB $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $00, $00, $00, $00
	.DB $FF, $FF, $FF, $FF, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
	.DB $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $FF, $FF, $FF, $FF
	.DB $00, $00, $00, $00, $00, $00, $6E, $3B, $13, $3B, $6E, $00
	.DB $00, $1E, $33, $1F, $33, $1F, $03, $03, $00, $3F, $33, $03
	.DB $03, $03, $03, $00, $00, $7F, $36, $36, $36, $36, $36, $00
	.DB $3F, $33, $06, $0C, $06, $33, $3F, $00, $00, $00, $7E, $1B
	.DB $1B, $1B, $0E, $00, $00, $66, $66, $66, $66, $3E, $06, $03
	.DB $00, $6E, $3B, $18, $18, $18, $18, $00, $3F, $0C, $1E, $33
	.DB $33, $1E, $0C, $3F, $1C, $36, $63, $7F, $63, $36, $1C, $00
	.DB $1C, $36, $63, $63, $36, $36, $77, $00, $38, $0C, $18, $3E
	.DB $33, $33, $1E, $00, $00, $00, $7E, $DB, $DB, $7E, $00, $00
	.DB $60, $30, $7E, $DB, $DB, $7E, $06, $03, $1C, $06, $03, $1F
	.DB $03, $06, $1C, $00, $1E, $33, $33, $33, $33, $33, $33, $00
	.DB $00, $3F, $00, $3F, $00, $3F, $00, $00, $0C, $0C, $3F, $0C
	.DB $0C, $00, $3F, $00, $06, $0C, $18, $0C, $06, $00, $3F, $00
	.DB $18, $0C, $06, $0C, $18, $00, $3F, $00, $70, $D8, $D8, $18
	.DB $18, $18, $18, $18, $18, $18, $18, $18, $18, $1B, $1B, $0E
	.DB $0C, $0C, $00, $3F, $00, $0C, $0C, $00, $00, $6E, $3B, $00
	.DB $6E, $3B, $00, $00, $1C, $36, $36, $1C, $00, $00, $00, $00
	.DB $00, $00, $00, $18, $18, $00, $00, $00, $00, $00, $00, $00
	.DB $18, $00, $00, $00, $F0, $30, $30, $30, $37, $36, $3C, $38
	.DB $1E, $36, $36, $36, $36, $00, $00, $00, $0E, $18, $0C, $06
	.DB $1E, $00, $00, $00, $00, $00, $3C, $3C, $3C, $3C, $00, $00
	.DB $00, $00, $00, $00, $00, $00, $00, $00
